unit upfile;

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
  ComObj, ActiveX, AspTlb, myobj_TLB, Classes, Variants, SysUtils, StdVcl, windows;

type
  Tupfile = class(TASPObject, Iupfile)
  public
  protected
    procedure OnEndPage; safecall;
    procedure OnStartPage(const AScriptingContext: IUnknown); safecall;
    procedure FileSaveAs(Filename: OleVariant); safecall;
    function Get_Form(Formname: OleVariant): OleVariant; safecall;
    function Get_FileName: OleVariant; safecall;
    function Get_FileSize: Integer; safecall;
    function Get_FileData: OleVariant; safecall;
    function Get_FileType: OleVariant; safecall;
  private
    FContentData:string;
    FFileData,FFileName,FFileType:string;
    FFormInfo:TStringList;
    function instr(str1,str2:string;startpos:integer):integer;
    procedure AnalyFormData(content:string);
  end;

implementation

uses ComServ;

procedure Tupfile.AnalyFormData(content: string);
var
  pos1,pos2:integer;
  FormName,FormValue:string;
  isFile:boolean;
begin
  isFile := false;
  pos1 := instr('name="',content,1)+6;
  pos2 := instr('"',content,pos1);
  FormName := copy(content,pos1,pos2-pos1);

  //Ƿļ
  pos1 := instr('filename="',content,pos2+1);
  if pos1 <> 0 then
  begin
    isFile := true;
    pos1 := pos1 + 10;
    pos2 := instr('"',content,pos1);
    FFilename := copy(content,pos1,pos2-pos1);
  end;

  pos1 := instr(#13#10#13#10,content,pos2+1)+4;
  FormValue := copy(content,pos1,length(content)-pos1);

  if isfile then
  begin
    FFileData := FormValue;
    //ļϢ
    pos2 := instr('Content-Type: ',content,pos2+1);
    if pos2 <> 0 then
    begin
      pos2 := pos2 + 14;
      FFileType := copy(content,pos2,pos1-4-pos2);
    end;
  end
  else
  begin
  FFormInfo.add(FormName+'='+FormValue);
  end;
end;

procedure Tupfile.FileSaveAs(Filename: OleVariant);
var
  fsout:TFileStream;
begin
  fsout := TFileStream.Create(Filename,fmcreate);
  try
    fsout.Write(Byte(FFileData[1]),Length(FFileData))
  finally
    fsout.Free;
  end;

end;

function Tupfile.Get_Form(Formname: OleVariant): OleVariant;
begin
    Result := FFormInfo.Values[Formname];
end;

function Tupfile.instr(str1, str2: string; startpos: integer): integer;
var
  tmp:integer;
begin
  tmp := pos(str1,copy(str2,startpos,length(str2)-startpos+1));
  Result := 0;
  if tmp <> 0 then
  begin
    Result := tmp + startpos-1;
  end;
end;

procedure Tupfile.OnEndPage;
begin
  FFormInfo.free;
  inherited OnEndPage;
end;

procedure Tupfile.OnStartPage(const AScriptingContext: IUnknown);
var
  AOleVariant : OleVariant;
  tmpvar : OleVariant;
  contentlength : integer;
  i,DeliCount,pos1,pos2,lastpos : integer;
  FDelimeter : string;
begin
  inherited OnStartPage(AScriptingContext);
  FFormInfo := TStringList.Create;

  contentlength := Request.TotalBytes;
  AOleVariant := contentlength;
  tmpvar := Request.BinaryRead(AOleVariant);

  for i := 1 to contentlength -1 do
  begin
    FContentData := FContentData + chr(byte(tmpvar[i]));
  end;

  pos1 := pos(#13#10,FContentData);
  FDelimeter := copy(FContentData,1,pos1+1);
  DeliCount := length(FDelimeter);
  lastpos := 1;

  pos1:=0;
  pos2:=0;
  while pos2>=pos1 do
  begin
    pos1 := instr(FDelimeter,FContentData,lastpos);
    if pos1 = 0 then Break;
    pos1 := pos1 + DeliCount;
    pos2 := instr(FDelimeter,FContentData,pos1)-1;
    AnalyFormData(copy(FContentData,pos1,pos2-pos1-1));
    lastpos := pos2;
  end;

end;


function Tupfile.Get_FileName: OleVariant;
begin
  Result := ExtractFileName(FFileName);
end;


function Tupfile.Get_FileSize: Integer;
begin
  Result := length(FFileData);
end;

function Tupfile.Get_FileData: OleVariant;
var
  i:integer;
begin
  Result := VarArrayCreate( [0,length(FFileData)], varByte );
  for i := 0 to length(FFileData)-1 do
  begin
    Result[i] := Byte(FFileData[i+1]);
  end;
end;

function Tupfile.Get_FileType: OleVariant;
begin
  Result := FFileType;
end;

initialization
  TAutoObjectFactory.Create(ComServer, Tupfile, Class_upfile,
    ciMultiInstance, tmApartment);
end.
